package no.statnett.ecp;

import org.apache.activemq.ActiveMQConnectionFactory;
import org.apache.activemq.broker.Broker;
import org.apache.activemq.broker.BrokerService;
import org.apache.activemq.broker.ConnectionContext;
import org.apache.activemq.broker.region.Destination;
import org.apache.activemq.broker.region.DestinationInterceptor;
import org.apache.activemq.broker.region.policy.PolicyEntry;
import org.apache.activemq.broker.region.policy.PolicyMap;
import org.apache.activemq.command.ActiveMQDestination;
import org.apache.activemq.command.ActiveMQQueue;

import javax.jms.*;


public class BrokerExample {

  public static void main2(String[] args) throws Exception {

    // create the destination interceptor to block messages on a specific queue
    DestinationInterceptor destinationInterceptor = new DestinationInterceptor() {
      @Override
      public Destination intercept(Destination destination) {
        if (destination.getActiveMQDestination() instanceof ActiveMQQueue) {
          ActiveMQQueue queue = (ActiveMQQueue) destination.getActiveMQDestination();
          if (queue.getPhysicalName().equals("myQueue")) {
            throw new RuntimeException("Sending messages to myQueue is not allowed");
          }
        }
        return destination;
      }

      @Override
      public void remove(Destination destination) {

      }

      @Override
      public void create(Broker broker, ConnectionContext connectionContext, ActiveMQDestination activeMQDestination) throws Exception {

      }
    };

  }

  public static void main(String[] args) throws Exception {

    // start the broker
/*
    BrokerService broker = new BrokerService();

    // Default - persisted broker, setup the server to listen on 61616
    //    brokerService.addConnector("tcp://localhost:61616");

    // Set a name for the broker and connect to via the name
    broker.setBrokerName("myBroker");

    broker.setUseJmx(true);
    broker.setPersistent(false);
*/

//    broker.start();

//    ConnectionFactory connectionFactory = new ActiveMQConnectionFactory("tcp://localhost:61616");
    ConnectionFactory connectionFactory = new ActiveMQConnectionFactory("vm://myBroker2");

    // create the connection and session
    Connection connection = connectionFactory.createConnection();
    connection.start();
    Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);

    // create the producer and the destination
    Queue myQueue = session.createQueue("myQueue");
    MessageProducer producer = session.createProducer(myQueue);

    // send a message to the queue
    TextMessage message = session.createTextMessage("Hello, world!");
    producer.send(message);
    producer.send(message);


    /*
    PolicyMap policyMap = broker.getDestinationPolicy();
    PolicyEntry policyEntry = policyMap.getEntryFor(destination);
    policyEntry.setProducerFlowControl(true);
*/



    // create the consumer and start listening for messages
    MessageConsumer consumer = session.createConsumer(session.createQueue("myQueue"));

    Message receivedMessage = consumer.receive();
    while (receivedMessage != null) {

      // print the received message content
      if (receivedMessage instanceof TextMessage) {
        TextMessage textMessage = (TextMessage) receivedMessage;
        System.out.println("Received message: " + textMessage.getText());
      } else {
        System.out.println("Received message of unsupported type");
      }
      receivedMessage = consumer.receive(1000);
    }

    // close the connection and session
    connection.close();
    session.close();

    // stop the broker
//    broker.stop();
  }
}
