package no.statnett.ecp.log;

public class Message {

  public static final long KILO = 1024L;

  private String messageId; // id
  private boolean snd; // snd/rcv
  private long bytes; // bytes
  private long ms; // duration
  private long tms; // epochTms
  private long tmpTms; // epochTms-start
  private long tmsHour; // yyyyMMddHH
  private String sender; // ecp-code
  private String receiver; // ecp-code
  private String broker; // ecp-code

  public Message(String messageId, boolean snd) {
    this.messageId = messageId;
    this.snd = snd;
  }

  public String getMessageId() {
    return messageId;
  }

  public String getDirection() {
    return snd ? "snd" : "rcv";
  }

  public long getKB() {
    return bytes / KILO;
  }

  public void setBytes(long bytes) {
    this.bytes = bytes;
  }

  public long getMs() {
    return ms;
  }

  public void setMs(long ms) {
    this.ms = ms;
  }

  public long getTms() {
    return tms;
  }

  public void setTms(long tms) {
    this.tms = tms;
  }

  public long getTmpTms() {
    return tmpTms;
  }

  public void setTmpTms(long tmpTms) {
    this.tmpTms = tmpTms;
  }

  public long getTmsHour() {
    return tmsHour;
  }

  public void setTmsHour(long tmsHour) {
    this.tmsHour = tmsHour;
  }

  public void setSender(String sender) {
    this.sender = sender;
  }

  public void setReceiver(String receiver) {
    this.receiver = receiver;
  }

  public String getOppositeEP() {
    return snd ? receiver : sender;
  }

  public String getMeasureEP() {
    return snd ? sender : receiver;
  }

  public String getBroker() {
    return broker;
  }

  public void setBroker(String broker) {
    this.broker = broker;
  }


}
